// FFHookTester.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "FFHookTester.h"

#include <iostream>
#include <string>

void CALLBACK WinEventProc(HWINEVENTHOOK hook, DWORD event, HWND hwnd,
    LONG idObject, LONG idChild,
    DWORD dwEventThread, DWORD dwmsEventTime)
{
    if (idChild != CHILDID_SELF || hwnd == nullptr || !IsWindow(hwnd))
    {
        return;
    }

    auto styles = ::GetWindowLongPtr(hwnd, GWL_STYLE);
    bool is_child = (styles & WS_CHILD) != 0;

    if (is_child)
        return;

    TCHAR buf[256] = {0};
    std::wstring outStr;
    if (event == EVENT_OBJECT_SHOW || event == EVENT_OBJECT_HIDE)
    {
        GetWindowText(hwnd, buf, sizeof(buf) / sizeof(buf[0]) - 1);
        TCHAR out[1024] = {0};
        _snwprintf(out, sizeof(out)/sizeof(out[0])-1, L"%s hwnd=0x%X, hook=0x%X", buf, hwnd, event);
        outStr = out;
        std::wcout << outStr << std::endl;
    }
}

int APIENTRY _tWinMain(_In_ HINSTANCE hInstance,
                     _In_opt_ HINSTANCE hPrevInstance,
                     _In_ LPTSTR    lpCmdLine,
                     _In_ int       nCmdShow)
{
	UNREFERENCED_PARAMETER(hPrevInstance);
	UNREFERENCED_PARAMETER(lpCmdLine);

    WNDCLASSEX wcex = {0};
    wcex.cbSize = sizeof(WNDCLASSEX);
    wcex.lpfnWndProc = DefWindowProc;
    wcex.lpszClassName = L"MSG_WINDOW";
    RegisterClassEx(&wcex);

    HWND hWnd = CreateWindow(L"MSG_WINDOW", NULL, 0,
        0, 0, 0, 0, HWND_MESSAGE, NULL, NULL, NULL);

    SetWinEventHook(EVENT_MIN, EVENT_MAX, NULL, WinEventProc, 0, 0, WINEVENT_OUTOFCONTEXT | WINEVENT_SKIPOWNPROCESS);

	MSG msg;
    BOOL bRet = 0;
    while ( (bRet=GetMessage(&msg, NULL, 0, 0)) )
	{
        if (bRet == -1)
        {
            break;
        }
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	return 0;
}

